// fixes sequential numbers

// a sample script for Adobe Illustrator CS3

// Hiroyuki Sato
// http://lines-about-to-be-generated.blogspot.com/

// 2010-01-29

main();
function main(){
  if( app.documents.length < 1 ){
    alert("there's no opened document");
    return;
  }
  
  var texts = [];
  var sel = app.activeDocument.selection;
  
  if(!(sel instanceof Array) || extractTextFrames(sel, texts) < 3){
    alert("please select 3 or more text objects");
    return;
  }

  var num_to   = texts[0].contents - 0;
  var num_from = texts[ texts.length - 1 ].contents - 0;
  var unit = (num_to - num_from) / (texts.length - 1);

  
  var digit = 0;
  if( texts[0].contents.match(/\.(\d+)/)){
    digit = RegExp.$1.length;
  }
  if( texts[ texts.length - 1 ].contents.match(/\.(\d+)/)){
    digit = Math.max( digit, RegExp.$1.length );
  }

  
  var leader = 0;
  if( texts[0].contents.match(/^0+\d*/)){
    leader = RegExp.lastMatch.length;
  }
  if( texts[ texts.length - 1 ].contents.match(/^0+\d*/)){
    leader = Math.max( leader, RegExp.lastMatch.length );
  }


  var s;
  for(var i = 0; i < texts.length; i++){
    s = (num_to - unit * i).toFixed(digit);
    
    if( leader > 1 ){
      while( s.match(/^\d+/)
             && RegExp.lastMatch.length < leader ){
        s = "0" + s;
      }
    }
    
    texts[i].contents = s;
  }
}

// --------------------------------------
function extractTextFrames(s, arr){
  for(var i = 0; i < s.length; i++){
    if(s[i].typename == "TextFrame"){
      if(s[i].textRange.characters.length > 0) arr.push(s[i]);
    } else if (s[i].typename == "GroupItem"){
      extractTextFrames(s[i].pageItems, arr);
    }
  }
  return arr.length;
}
