SEL = app.activeDocument.selection
LAY = app.activeDocument.activeLayer
STB = app.preferences.getBooleanPreference("includeStrokeInBounds")
CKL = app.preferences.getRealPreference("cursorKeyLength")
RUL = app.preferences.getIntegerPreference("rulerType")
R1 = ["inch","mm","pt","pica","cm","H","px"]

MAINfn()

function MAINfn(){
	if(SEL.length<2) return false
	Q1=[], P1=[], WID=0
	for(s=0; s<SEL.length; s++) SELfn(SEL[s])
	if(Q1.length==0||P1.length==0) return false
	FIL = Q1[0].fillColor
	DSP = prompt("Desired spacing between boxes (" + "" + R1[RUL] + "）", RULfn(CKL, "pt", R1[RUL]))
	if(!DSP || isNaN(DSP)) return false
	SEN = RULfn(DSP, R1[RUL], "pt")
	LEN = P1.length
	MAXfn(Q1)
	T1 = B0[1], L1 = B0[0]
	DIV = (B0[2]-B0[0]-SEN*(LEN-1)-WID)/LEN
	W1 = DIV
	H1 = B0[1]-B0[3]
	NEWfn()
	P2 = SORTfn(P1)
	W2 = 0
	for(a=0; a<P2.length; a++) {
		DUP = NEW.duplicate()
		DUP.width = P2[a].width + DIV
		DUP.move(LAY, ElementPlacement.PLACEATEND)
		Tx = W2
		DUP.translate(Tx,0)
		TRNfn(DUP,P2[a])
		W2 += DUP.width + SEN
	}
	NEW.remove()
	for(a=0; a<Q1.length; a++) Q1[a].remove()
}

function RULfn(u0, u1, u2){
	Rr = Math.round(new UnitValue(u0, u1).as(u2)*1000)/1000
	return Rr
}

function SELfn(Ss){
	if(Ss.typename == 'TextFrame'){
		P1.push(Ss)
		WID += Ss.width
	} else {
		Q1.push(Ss)
	}
}

function NEWfn(){
	NEW = LAY.pathItems.rectangle(T1,L1,W1,H1)
	NEW.filled = true
	NEW.fillColor = FIL
	NEW.stroked = false	
}

function TRNfn(S1,S2){
	B1 = BNDfn(S1)
	B2 = BNDfn(S2)
	Tx = (B1[0]+B1[2])/2 - (B2[0]+B2[2])/2
	Ty = (B1[1]+B1[3])/2 - (B2[1]+B2[3])/2
	S2.translate(Tx,Ty)
}

function MAXfn(Mm){
	B0 = BNDfn(Mm[0])
	for(m=1; m<Mm.length; m++){
		Bm = BNDfn(Mm[m])
		B0[0] = Math.min(B0[0],Bm[0])
		B0[1] = Math.max(B0[1],Bm[1])
		B0[2] = Math.max(B0[2],Bm[2])
		B0[3] = Math.min(B0[3],Bm[3])
	}
}

function BNDfn(Bb){
	Bz = Bb.geometricBounds
	if(STB) Bz = Bb.visibleBounds
	if(Bb.clipped) Bz = Bb.pageItems[0].geometricBounds
	return Bz
}

function SORTfn(f0){
	f1 = []
	for(f=0; f<f0.length; f++) f1.push(f0[f])
	f1.sort(
		function(a,b){
			a0 = Math.round(a.position[0])
			a1 = Math.round(a.position[1])
			b0 = Math.round(b.position[0])
			b1 = Math.round(b.position[1])
			if(a0 < b0) return -1
			if(a0 > b0) return 1
			if(a0== b0) return 0
		}
	)
	return f1
}